package com.ekingwin.bas.cloud.purchase.dao;

import com.ekingwin.bas.cloud.portal.vo.PurchasingPlatformAddVo;
import com.ekingwin.bas.cloud.portal.vo.PurchasingPlatformOrderAddVo;
import com.ekingwin.bas.cloud.purchase.dto.IpcCart2Dto;
import com.ekingwin.bas.cloud.purchase.dto.OrderDto;
import com.ekingwin.bas.cloud.purchase.dto.OrderIdAndStateDto;
import com.ekingwin.bas.cloud.purchase.dto.ReplyGetGoodsDto;
import com.ekingwin.bas.cloud.purchase.vo.GetOrderVo;
import com.ekingwin.bas.cloud.purchase.vo.ReplyOrderVo;
import org.apache.ibatis.annotations.Param;

import java.math.BigInteger;
import java.util.List;
import java.util.Map;

/**
 * @author kan
 * @version 1.0.0
 * @ClassName SpecicalPurchaseDao.java
 * @Description TODO
 * @createTime 2020/4/7 11:10
 */
public interface SpecicalPurchaseDao {
    List<Map<String,String>> getGoods1(String empuid);

    List<Map<String,String>> getGoods2(String companyid);

    List<IpcCart2Dto> getGoods3(@Param("ids")String ids);

    List<Map<String,String>> getGoods4(@Param("ids") String ids,@Param("goodsid")  int goodsid,@Param("userid") String userid,
                        @Param("jcybasUrl") String jcybasUrl,@Param("twbusUrl") String twbusUrl);

    List<Map<String,String>> getGoods5(@Param("supplierid")String supplierid, @Param("twbusUrl")String twbusUrl);

    String getPonum(String ponum);

    int getdraftsid(String ponum);

    Boolean deletedraftsid(int draftsid);

    void addorder(PurchasingPlatformAddVo purchasingPlatformAddVo);

    void updateprocessid(@Param("ordernum") String ordernum,@Param("processid")String processid);

    Boolean updatestate(@Param("state")String state, @Param("processid")String processid);

    Boolean updatestate2(ReplyOrderVo replyOrderVo);

    String getordertype(String ordernum);

    Boolean updateallgoods(@Param("provstatus")String provstatus,@Param("ordernum")String ordernum);

    OrderDto getorder(String ordernum);

    Boolean addorderfaillogs(OrderDto orderDto);

    Boolean updateorderbpmurl(@Param("detaillink")String detaillink,@Param("ordernum")String ordernum);

    /**
     * 查询ip_c_order的id以及状态
     * @param purchasingPlatformAddVo
     * @return
     */
    OrderIdAndStateDto queryorderidandstate(PurchasingPlatformAddVo purchasingPlatformAddVo);


    /**
     * 添加到ip_c_order_allgoods表
     * @param purchasingPlatformOrderAddVo
     */
    void addOrderAllGoods(PurchasingPlatformOrderAddVo purchasingPlatformOrderAddVo);

    /**
     * 添加到ip_c_order_attachment
     * @param purchasingPlatformAddVo
     */
    void addOrderAttachment(PurchasingPlatformAddVo purchasingPlatformAddVo);

    List<Map<String,String>> getallgoods1(ReplyGetGoodsDto replyGetGoodsDto);

    Map<String,String> verifyAllGoods(GetOrderVo orderVo);

    void updateAllGoods(@Param("state") String state,@Param("ordernum") String ordernum,@Param("materielsid") String materielsid);

    void updateipsgoods(@Param("goodsid")  String goodsid,@Param("receiptcount")  BigInteger receiptcount,@Param("twbusUrl") String twbusUrl);

    Map<String,String> getprice(GetOrderVo orderVo);

    void addipcreceipt(GetOrderVo orderVo);

    void updateipcreceipt(@Param("newdate") String newdate,@Param("receiptcount") BigInteger receiptcount,@Param("ordernum") String ordernum,
                          @Param("bhsprice")String bhsprice,@Param("hsprice")String hsprice);

    void addicpreceiptallgoods(@Param("receiptid")String receiptid, @Param("ordernum")String ordernum,
                               @Param("materielsid")String materielsid,@Param("receiptcount") BigInteger receiptcount);
}
